#include <hardware/gpio.h>
#include <hardware/irq.h>
#include <hardware/pwm.h>

void on_pwm_wrap()
{
  static int fade = 0;
  static bool going_up = true;

  pwm_clear_irq(pwm_gpio_to_slice_num(ICE_LED_RED_PIN));

  if (going_up)
  {
    if (++fade > 255)
    {
      fade = 255;
      going_up = false;
    }
  }
  else
  {
    if (--fade < 0)
    {
      fade = 0;
      going_up = true;
    }
  }

  pwm_set_gpio_level(ICE_LED_RED_PIN, fade * fade);
}

int main()
{
  gpio_set_function(ICE_LED_RED_PIN, GPIO_FUNC_PWM);
  uint slice_num = pwm_gpio_to_slice_num(ICE_LED_RED_PIN);

  pwm_clear_irq(slice_num);
  pwm_set_irq_enabled(slice_num, true);
  irq_set_exclusive_handler(PWM_DEFAULT_IRQ_NUM(), on_pwm_wrap);
  irq_set_enabled(PWM_DEFAULT_IRQ_NUM(), true);

  pwm_config config = pwm_get_default_config();
  pwm_config_set_clkdiv(&config, 1.0f);

  pwm_init(slice_num, &config, true);

  while (true);
}
